var Api = {};
Api.config = {
    version: 10400,
    versionStr: '1.4.0',
    host: 'http://c3382.daqianfozhu.com',
    apihost: 'http://c3382.daqianfozhu.com/api/app'
};
Api.help = new function() {
    var self = this;
    var xPi = (3.14159265358979324 * 3000.0) / 180.0;
    this.delHtmlTag = function(str) {
        return str.replace(/<[^>]+>/g, '');
    };
    this.dateFormat = function(date, format) {
        !format && ((format = date), (date = this));
        date = new Date(date);
        var map = {
            M: date.getMonth() + 1, //月份
            d: date.getDate(), //日
            h: date.getHours(), //小时
            m: date.getMinutes(), //分
            s: date.getSeconds(), //秒
            q: Math.floor((date.getMonth() + 3) / 3), //季度
            f: date.getMilliseconds() //毫秒
        };
        format = format.replace(/([yMdhmsqf])+/g, function(all, t) {
            var v = map[t];
            if (v !== undefined) {
                if (all.length > 1) {
                    v = '0' + v;
                    v = v.substr(v.length - 2);
                }
                return v;
            } else if (t === 'y') {
                return (date.getFullYear() + '').substr(4 - all.length);
            }
            return all;
        });
        return format;
    };
    this.formatTime = function(t) {
        if (t) {
            if (t.getTime) {
                return t;
            } else if (typeof t === 'number') {
                return new Date(t);
            } else if (typeof t === 'string') {
                if (!t.length || t.length < 5) return '';
                return new Date(t.replace(/-/g, '/'));
            }
        }
        return '';
    };
    this.formatTimeNow = function(tobj) {
        var ttime = self.formatTime(tobj);
        var now = new Date();
        var day = self.dateFormat(ttime, 'yyyy-MM-dd');
        var today = self.dateFormat(now, 'yyyy-MM-dd');
        var yestoday = self.dateFormat(now.getTime() - 86400000, 'yyyy-MM-dd');

        function name(h) {
            if (h < 12) return '上午';
            return '下午';
        }
        return (
            (day == today ? '' : day == yestoday ? '昨天 ' : day) +
            name(ttime.getHours()) +
            self.dateFormat(ttime, 'hh:mm')
        );
    };
    this.urlsearch = function(name, location) {
        var url = location || window.location.toString();
        var i = url.indexOf('?') || 0;
        var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)', 'i');
        var r = url.substr(i + 1).match(reg);
        if (r != null) return decodeURI(r[2]);
        return '';
    };
    this.distance = function(lat1, lng1, lat2, lng2) {
        function rad(d) {
            return (d * Math.PI) / 180.0;
        }
        var radLat1 = rad(lat1);
        var radLat2 = rad(lat2);
        var a = radLat1 - radLat2;
        var b = rad(lng1) - rad(lng2);

        var s =
            2 *
            Math.asin(
                Math.sqrt(
                    Math.pow(Math.sin(a / 2), 2) +
                        Math.cos(radLat1) *
                            Math.cos(radLat2) *
                            Math.pow(Math.sin(b / 2), 2)
                )
            );
        s = s * 6378.137;
        s = Math.round(s * 1000);
        return s;
    };
    this.convertImgToBase64 = function(url, callback, outputFormat) {
        var canvas = document.createElement('CANVAS'),
            ctx = canvas.getContext('2d'),
            img = new Image();
        img.crossOrigin = 'Anonymous';
        img.onload = function() {
            canvas.height = img.height;
            canvas.width = img.width;
            ctx.drawImage(img, 0, 0);
            var dataUrl = canvas.toDataURL(outputFormat || 'image/jpg');
            callback.call(this, dataUrl);
            canvas = null;
        };
        img.src = url;
    };
    this.gcToBd = function(latlng) {
        var x = latlng.lng,
            y = latlng.lat;
        var z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * xPi);
        var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * xPi);
        var bdLon = z * Math.cos(theta) + 0.0065;
        var bdLat = z * Math.sin(theta) + 0.006;
        return {
            lng: parseFloat(bdLon.toFixed(6)),
            lat: parseFloat(bdLat.toFixed(6))
        };
    };
    this.bdToGc = function(latlng) {
        var x = latlng.lng - 0.0065,
            y = latlng.lat - 0.006;
        var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * xPi);
        var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * xPi);
        var ggLon = z * Math.cos(theta);
        var ggLat = z * Math.sin(theta);
        return {
            lng: parseFloat(ggLon.toFixed(6)),
            lat: parseFloat(ggLat.toFixed(6))
        };
    };
    this.exmth = function() {
        String.prototype.trim = function() {
            return this.replace(/(^\s*)|(\s*$)/g, '');
        };
        String.prototype.ltrim = function() {
            return this.replace(/(^\s*)/g, '');
        };
        String.prototype.rtrim = function() {
            return this.replace(/(\s*$)/g, '');
        };
        String.prototype.format = function(args) {
            var result = this;
            if (arguments.length > 0) {
                if (arguments.length == 1 && typeof args == 'object') {
                    for (var key in args) {
                        if (args[key] != undefined) {
                            var reg = new RegExp('({' + key + '})', 'g');
                            result = result.replace(reg, args[key]);
                        }
                    }
                } else {
                    for (var i = 0; i < arguments.length; i++) {
                        if (arguments[i] != undefined) {
                            var reg = new RegExp('({[' + i + ']})', 'g');
                            result = result.replace(reg, arguments[i]);
                        }
                    }
                }
            }
            return result;
        };
        Date.prototype.format = this.dateFormat;
    };
    this.exmth();
}();
Api.device = new function() {
    var self = this;
    //系统类型
    this.systemType = '';
    this.winWidth = 0;
    this.winHeight = 0;
    this.init = function() {
        this.systemType = api.systemType;
        this.winWidth = window.api.winWidth;
        this.winHeight = window.api.winHeight;
        this.info = {
            SystemType: api.systemType,
            DeviceId: api.deviceId,
            DeviceModel: api.deviceModel
        };
    };
    //播放音乐
    this.playAudio = function(path, call) {
        window.api.startPlay(
            {
                path: path
            },
            call
        );
    };
    //停止播放音乐
    this.stopPlay = function() {
        window.api.stopPlay();
    };
    //停止录音
    this.stopRecord = function(cb) {
        api.stopRecord(function(ret, err) {
            if (ret) {
                cb(ret);
            } else {
                Api.msg.toast('说话时间太短！');
            }
        });
    };
    //录制音频
    this.startRecord = function() {
        api.startRecord();
    };
    //拨打电话
    this.tel = function(num) {
        if (api.systemType == 'ios') {
            api.call({
                type: 'tel_prompt',
                number: num
            });
        } else {
            Api.msg.confirm('提示', '是否拨打' + num + '？', function(r) {
                if (r) {
                    api.call({
                        type: 'tel_prompt',
                        number: num
                    });
                }
            });
        }
    };
    //打开相册或相机
    this.openImage = function(opt, call) {
        window.api.actionSheet(
            {
                cancelTitle: '取消',
                buttons: ['相册', '拍照']
            },
            function(ret) {
                if (ret.buttonIndex == 3) return;
                window.api.getPicture(
                    {
                        sourceType:
                            ret.buttonIndex === 1 ? 'library' : 'camera',
                        encodingType: 'jpg',
                        mediaValue: 'pic',
                        quality: 100,
                        destinationType: 'url',
                        allowEdit: opt.cut != false
                    },
                    function(ret) {
                        if (ret && ret.data) {
                            call && call(ret.data);
                        }
                    }
                );
            }
        );
    };
    this.cutimg = function(img, call, opt) {
        Api.page.openFrame({
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto'
            },
            name: 'frameimgcut',
            url: '/pages/main/imgcut.html',
            pageParam: {
                img: img,
                winName: api.winName,
                frameName: api.frameName,
                w: (opt && opt.w) || 300,
                h: (opt && opt.h) || 300
            },
            bounces: false
        });
        self.cutimgcall = call;
    };
    //预览图片
    this.previewImage = function(imgs, index) {
        var photoBrowser = api.require('photoBrowser');
        photoBrowser.open({
            images: imgs,
            bgColor: '#000',
            activeIndex: index || 0
        });
        api.openFrame({
            bounces: false,
            name: 'frameimgpre',
            url: '../main/imgpre.html',
            bgColor: '#000000',
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: '80'
            },
            pageParam: {
                name: api.frameName
            }
        });
        this.closeimgpre = function() {
            photoBrowser.close();
            api.closeFrame({
                name: 'frameimgpre'
            });
        };
        this.saveimgpre = function() {
            photoBrowser.getImage(
                {
                    index: 0
                },
                function(ret) {
                    api.saveMediaToAlbum(
                        {
                            path: ret.path
                        },
                        function(ret) {
                            if (ret && ret.status) {
                                Api.msg.toast('保存成功');
                            } else {
                                Api.msg.alert('保存失败');
                            }
                        }
                    );
                }
            );
        };
    };
    //浏览器支持动画结束类型
    this.animationEnd = function() {
        var anm = ['animation', 'OAnimation', 'msAnimation', 'WebkitAnimation'];
        var aname = {
            WebkitAnimation: 'webkitAnimationEnd',
            OAnimation: 'oAnimationEnd',
            msAnimation: 'MSAnimationEnd',
            animation: 'animationend'
        };
        for (var i = 0; i < anm.length; i++) {
            if (document.body.style[anm[i]] !== undefined) {
                return aname[anm[i]];
            }
        }
        return 'webkitAnimationEnd';
    };
    //定位
    this.location = function(call) {
        var bMap = api.require('bMap');
        bMap.getLocation(
            {
                accuracy: '100m',
                autoStop: true,
                filter: 1
            },
            function(ret) {
                bMap.stopLocation();
                if (ret.status) {
                    call(
                        Api.help.bdToGc({
                            lng: ret.lon,
                            lat: ret.lat
                        })
                    );
                } else {
                    bMap.getLocationServices(function(ret, err) {
                        if (
                            !ret.authorizationStatus ||
                            ret.authorizationStatus === 'denied' ||
                            ret.authorizationStatus === 'restricted' ||
                            ret.authorizationStatus === 'notDetermined'
                        ) {
                            api.msg.alert(
                                '请授权获取地理位置信息！',
                                function() {
                                    api.systemType == 'ios'
                                        ? (api.openApp({
                                              iosUrl: 'app-settings:'
                                          }),
                                          console.log('alert11'),
                                          api.msg.alert(
                                              '请授权获取地理位置信息！',
                                              function() {
                                                  Api.device.location(call);
                                              }
                                          ))
                                        : api
                                              .require('mySettingInfo')
                                              .settingInt(
                                                  {
                                                      index: 2
                                                  },
                                                  function(ret, err) {
                                                      Api.device.location(call);
                                                  }
                                              );
                                }
                            );
                        } else {
                            call({ lng: 114.057869, lat: 22.543098 });
                        }
                    });
                }
            }
        );
    };
    //导航
    this.navigation = function(start, end, sname, dname) {
        var amap = api.appInstalled({
            sync: true,
            appBundle:
                api.systemType === 'android'
                    ? 'com.autonavi.minimap'
                    : 'iosamap'
        });
        var bmap = api.appInstalled({
            sync: true,
            appBundle:
                api.systemType === 'android' ? 'com.baidu.BaiduMap' : 'baidumap'
        });
        var qqmap = api.appInstalled({
            sync: true,
            appBundle:
                api.systemType === 'android' ? 'com.tencent.map' : 'qqmap'
        });
        var bttons = [];
        amap && bttons.push('高德地图');
        bmap && bttons.push('百度地图');
        qqmap && bttons.push('腾讯地图');
        if (api.systemType == 'ios') {
            bttons.push('苹果地图');
        }
        if (bttons.length === 0) return api.msg.toast('你未安装任何地图');
        api.actionSheet(
            {
                title: '调起导航',
                cancelTitle: '取消',
                buttons: bttons
            },
            function(ret, err) {
                if (bttons[ret.buttonIndex - 1] == '高德地图') {
                    window.location = '{action}://navi?sourceApplication=偷闲&backScheme=leisure&poiname=&poiid=&lat={dlat}&lon={dlon}&dev=1&style=2'.format(
                        {
                            action:
                                api.systemType === 'android'
                                    ? 'androidamap'
                                    : 'iosamap',
                            dlon: end.lng,
                            dlat: end.lat,
                            city: ''
                        }
                    );
                } else if (bttons[ret.buttonIndex - 1] == '百度地图') {
                    if (api.systemType === 'android') {
                        window.location = 'bdapp://map/navi?location={dlat},{dlon}'.format(
                            {
                                dlon: end.lng,
                                dlat: end.lat
                            }
                        );
                    } else {
                        start = Api.help.gcToBd(start);
                        end = Api.help.gcToBd(end);
                        window.location = '{action}://map/direction?origin={slat},{slon}&destination={dlat},{dlon}&mode=driving&region={city}&src=偷闲'.format(
                            {
                                action: 'baidumap',
                                slon: start.lng,
                                slat: start.lat,
                                sname: sname,
                                dlon: end.lng,
                                dlat: end.lat,
                                dname: dname,
                                city: ''
                            }
                        );
                    }
                } else if (bttons[ret.buttonIndex - 1] == '苹果地图') {
                    window.location = 'http://maps.apple.com/?sll={dlat},{dlon}&daddr=${dname}'.format(
                        {
                            sname: sname,
                            dlon: end.lng,
                            dlat: end.lat,
                            dname: dname
                        }
                    );
                } else if (bttons[ret.buttonIndex - 1] == '腾讯地图') {
                    window.location = 'qqmap://map/marker?marker=coord:{dlat},{dlon};title:${dname}&referer=偷闲'.format(
                        {
                            sname: sname,
                            dlon: end.lng,
                            dlat: end.lat,
                            dname: dname
                        }
                    );
                }
            }
        );
    };
}();
Api.msg = new function() {
    this.alert = function(title, msg, call, buttons) {
        if (typeof msg == 'function' || !msg) {
            call = msg;
            msg = title;
            title = '提示';
        }
        window.api.alert(
            {
                title: title,
                msg: msg,
                buttons: buttons || ['确定']
            },
            function() {
                call && call();
            }
        );
    };
    this.confirm = function(title, msg, call, buttons) {
        if (typeof msg == 'function' || !msg) {
            call = msg;
            msg = title;
            title = '提示';
        }
        if (api.systemType == 'ios') {
            window.api.confirm(
                {
                    title: title,
                    msg: msg,
                    buttons: buttons || ['取消', '确定']
                },
                function(ret) {
                    call && call(ret.buttonIndex === 2);
                }
            );
        } else {
            Api.msg.confirmcb = call;
            api.openFrame({
                name: 'frameconfirm',
                url: 'widget://pages/main/confirm.html',
                rect: {
                    x: 0,
                    y: 0,
                    w: 'auto',
                    h: 'auto'
                },
                bgColor: 'rgba(0, 0, 0, 0.3)',
                pageParam: {
                    title: title,
                    msg: msg,
                    buttons: buttons || ['取消', '确定'],
                    frameName: api.frameName
                }
            });
        }
    };
    this.toast = function(msg) {
        window.api.toast({
            msg: msg,
            duration: 3000,
            global: false,
            location: 'middle'
        });
    };
    this.loading = function(msg) {
        window.api &&
            window.api.showProgress({
                style: 'default',
                animationType: 'fade',
                text: '',
                title: msg,
                modal: true
            });
    };
    this.closeloading = function() {
        window.api.hideProgress();
    };
    this.err = this.toast;
}();
Api.db = new function() {
    this.get = function(key) {
        var v = api.getPrefs({
            sync: true,
            key: key
        });
        if (!v) return null;
        try {
            return JSON.parse(v);
        } catch (error) {
            return v;
        }
    };
    this.set = function(key, v) {
        if (v) {
            var v = typeof v == 'object' ? JSON.stringify(v) : v;
            api.setPrefs({
                key: key,
                value: v
            });
        } else {
            api.removePrefs({
                key: key
            });
        }
    };
    this.clear = function(key) {
        api.removePrefs({
            key: key
        });
    };
}();
Api.validate = new function() {
    var t = this;
    var currentForm = null,
        ele = null;

    function getele() {
        var fs = [];
        var f;
        for (var i = 0; i < currentForm[0].length; i++) {
            f = currentForm[0][i];
            if (
                'submit,button,reset,image'.indexOf(f.type.toLocaleString()) ===
                    -1 &&
                !f.disabled
            ) {
                fs.push(f);
            }
        }
        return fs;
    }

    function fmtmsg(msg, v) {
        return msg && msg.replace && msg.replace('{0}', v);
    }
    this.validate = function(form, all) {
        currentForm = $(form);
        ele = getele();
        var end = all === true;
        var isvali = true;
        for (var i = 0; i < ele.length; i++) {
            if (!t.valid(ele[i], t.showmsg, true)) {
                isvali = false;
                if (!end) return false;
            }
        }
        return isvali;
    };
    this.valiing = function(form) {
        currentForm = $(form);
        ele = getele();
        for (var i = 0; i < ele.length; i++) {
            if (!t.valid(ele[i], t.showmsging, false)) {
                $(ele[i]).keyup(function() {
                    t.valid(this, t.showmsging);
                });
                $(ele[i]).change(function() {
                    t.valid(this, t.showmsging);
                });
            }
        }
    };
    this.valid = function(e, fnmsg, focus) {
        fnmsg = fnmsg || t.showmsg;
        var $e = $(e);
        e = $e[0];
        var v = $.trim($e.val());
        //验证是否必须输入
        var vr = $e.attr('required');
        var m;
        if (vr != undefined && !t.methods.required(v, e)) {
            m =
                $e.attr('requiredmsg') ||
                $e.attr('placeholder') ||
                e.title ||
                t.messages.required;
            fnmsg && fnmsg(m, e, 'required', false);
            if (focus) $e.focus();
            return false;
        }
        if (v.length === 0) {
            fnmsg && fnmsg('', e, 'required', true);
            return true;
        }
        //验证type项
        vr = e.getAttribute('type') && e.getAttribute('type').toLowerCase();
        if (vr && vr !== 'text' && t.methods[vr] && !t.methods[vr](v, vr)) {
            m = e.getAttribute(vr + 'msg') || e.title || t.messages[vr];
            fnmsg && fnmsg(m, e, vr, false);
            $e.focus();
            return false;
        }
        //验证特性项
        for (var i = 0; i < t.features.length; i++) {
            var f = t.features[i];
            if (typeof f === 'string') {
                vr = e.getAttribute(f);
                if (vr === '') vr = f;
                if (vr && t.methods[f] && !t.methods[f](v, vr)) {
                    m =
                        e.getAttribute(f + 'msg') ||
                        e.title ||
                        fmtmsg(t.messages[f], vr);
                    fnmsg && fnmsg(m, e, vr, false);
                    $e.focus();
                    return false;
                }
            }
        }
        return true;
    };
    this.features = [
        'min',
        'max',
        'number',
        'minlength',
        'maxlength',
        'chs',
        'zip',
        'qq',
        'phone',
        'mobile',
        'landline',
        'idcard',
        'pattern',
        'equalto',
        'url'
    ];
    this.methods = {
        required: function(v) {
            return v && v.replace(/(^\s*)|(\s*$)/g, '').length > 0;
        },
        min: function(v, p) {
            return parseFloat(v) >= parseFloat(p);
        },
        max: function(v, p) {
            return parseFloat(v) <= parseFloat(p);
        },
        minlength: function(v, p) {
            return v.replace(/(^\s*)|(\s*$)/g, '').length >= p;
        },
        maxlength: function(v, p) {
            return v.replace(/(^\s*)|(\s*$)/g, '').length <= p;
        },
        email: function(v) {
            return /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i.test(
                v
            );
        },
        url: function(v) {
            return this.isurl(v);
        },
        number: function(v) {
            return /^-?(?:\d+|\d{1,3}(?:,\d{3})+)(?:\.\d+)?$/.test(v);
        },
        chs: function(v) {
            return /^[\u0391-\uFFE5]+$/.test(v);
        },
        zip: function(v) {
            return /^[1-9]\d{5}$/.test(v);
        },
        qq: function(v) {
            return /^[1-9]\d{4,10}$/.test(v);
        },
        phone: function(v) {
            return this.mobile(v) || this.landline(v);
        },
        mobile: function(v) {
            return /^((\(\d{2,3}\))|(\d{3}\-))?1\d{10}$/.test(v);
        },
        landline: function(v) {
            return /^(\(\d{3,4}\)|\d{3,4}-)?\d{7,8}$/.test(v);
        },
        idcard: function(v1) {
            var isDateTime = function() {
                var time = new Date(this);
                var m = time.getMonth() + 1;
                var d = time.getDate();
                var f =
                    time.getFullYear() +
                    '-' +
                    (m > 9 ? m : '0' + m) +
                    '-' +
                    (d > 9 ? d : '0' + d);
                return this.toString() === f;
            };
            var idCard = function(value) {
                if (value.length === 18 && 18 !== value.length) return false;
                var number = value.toLowerCase();
                var d,
                    sum = 0,
                    v = '10x98765432',
                    w = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2],
                    a =
                        '11,12,13,14,15,21,22,23,31,32,33,34,35,36,37,41,42,43,44,45,46,50,51,52,53,54,61,62,63,64,65,71,81,82,91';
                var re = number.match(
                    /^(\d{2})\d{4}(((\d{2})(\d{2})(\d{2})(\d{3}))|((\d{4})(\d{2})(\d{2})(\d{3}[x\d])))$/
                );
                if (re == null || a.indexOf(re[1]) < 0) return false;
                if (re[2].length === 9) {
                    number = number.substr(0, 6) + '19' + number.substr(6);
                    d = ['19' + re[4], re[5], re[6]].join('-');
                } else d = [re[9], re[10], re[11]].join('-');
                if (!isDateTime.call(d)) return false;
                for (var i = 0; i < 17; i++) sum += number.charAt(i) * w[i];
                return (
                    re[2].length === 9 ||
                    number.charAt(17) === v.charAt(sum % 11)
                );
            };
            return idCard(v1);
        },
        isurl: function(url) {
            var strRegex =
                '^((https|http|ftp|rtsp|mms)?://)' +
                "?(([0-9a-z_!~*'().&=+$%-]+: )?[0-9a-z_!~*'().&=+$%-]+@)?" + //ftp的user@
                '(([0-9]{1,3}.){3}[0-9]{1,3}' + // IP形式的URL- 199.194.52.184
                '|' + // 允许IP和DOMAIN（域名）
                "([0-9a-z_!~*'()-]+.)*" + // 域名- www.
                '([0-9a-z][0-9a-z-]{0,61})?[0-9a-z].' + // 二级域名
                '[a-z]{2,6})' + // first level domain- .com or .museum
                '(:[0-9]{1,4})?' + // 端口- :80
                '((/?)|' + // a slash isn't required if there is no file name
                "(/[0-9a-z_!~*'().;?:@&=+$,%#-]+)+/?)$";
            var re = new RegExp(strRegex);
            return re.test(url);
        }
    };
    this.messages = {
        required: '什么都不写么？',
        pattern: '不符合验证规则',
        max: '请输入一个小于或等于{0}的值',
        min: '请输入一个大于或等于{0}的值',
        maxlength: '长度应小于{0}位',
        minlength: '长度应大于{0}位',
        email: '邮箱地址这样不对吧！',
        url: '网址这样不对吧！',
        number: '只能输入数字哦！',
        chs: '只能输入汉字哦！',
        zip: '邮政编码不正确！',
        qq: 'QQ号码不正确！',
        tel: '电话号码不正确',
        mobile: '手机号码不正确！',
        phone: '固定电话号码不正确！',
        idcard: '请输入正确的身份证号码',
        equalto: '输入不匹配'
    };
    this.showmsg = function(msg, e, m, ok) {
        if (!ok) {
            var p = $(e);
            p.focus();
            Api.msg.toast(msg);
        }
    };
    this.showmsgingobj = null;
    window.$ &&
        ($.fn.validate = function(all) {
            return t.validate(this, all);
        });
}();
Api.promise = function() {
    var me = {};
    var self = this;
    this.then = function(cb) {
        me.thendata ? cb(me.thendata) : (self.success = cb);
        return self;
    };
    this.catch = function(cb) {
        me.errordata ? cb(me.errordata) : (self.error = cb);
        return self;
    };
    this.success = function(data) {
        me.thendata = data;
    };
    this.error = function(data) {
        me.errordata = data;
    };
    return this;
};
Api.net = new function() {
    this.ajaxjson = function(url, data, opt) {
        opt = opt || {};
        opt.errmsg = opt.errmsg || '请稍后再试';
        opt.visible !== false && api.msg.loading(opt.msg, 'net');
        var req = new api.promise();
        opt.errfn = function(d) {
            opt.visible != false && api.msg.closeloading('net');
            d.tip === 'alert' || d.action == 'close'
                ? api.msg.alert((d && d.msg) || opt.errmsg, function() {
                      d.action == 'close' && api.page.back();
                  })
                : opt.visible != false &&
                  d.code == undefined &&
                  api.msg.toast((d && d.msg) || opt.errmsg);
            req.error(d);
        };
        data = data || {};
        data.version = api.config.version;
        data.device_id = api.device.info.DeviceId;
        api.ajax(
            {
                url: (opt.apihost || api.config.apihost) + url,
                method: 'post',
                timeout: 5000,
                dataType: 'json',
                headers: {
                    authtoken: this.authtoken || (this.authtoken = Api.db.get('authtoken')),
                    'Content-Type': 'application/json',
                },
                data: {
                    body: data
                }
            },
            function(d, err) {
                if (d) {
                    opt.visible !== false && api.msg.closeloading();
                    if (d.success) {
                        d.authtoken &&
                            ((self.authtoken = d.authtoken),
                            Api.db.set('authtoken', d.authtoken));
                        d.tip === 'alert' && api.msg.alert(d.msg);
                        req.success(d);
                    } else {
                        opt.errfn(d);
                    }
                } else {
                    opt.errfn(err);
                }
            }
        );
        return req;
    };
    this.upfile = function(url, data, file, success, opt) {
        opt = opt || {};
        opt.errfn = function(d) {
            Api.msg.closeloading();
            d.tip === 'alert'
                ? Api.msg.alert((d && d.msg) || opt.errmsg)
                : opt.visible !== false &&
                  Api.msg.toast((d && d.msg) || opt.errmsg);
            opt.error && opt.error(d);
            d.action == 'close' && Api.page.back();
        };
        api.ajax(
            {
                url: (opt.apihost || api.config.apihost) + url,
                method: 'post',
                dataType: 'json',
                headers: {
                    authtoken:
                        this.authtoken ||
                        (this.authtoken = Api.db.get('authtoken'))
                },
                data: {
                    values: data,
                    files: file
                }
            },
            function(d, err) {
                if (d) {
                    if (d.success) {
                        d.authtoken &&
                            ((self.authtoken = d.authtoken),
                            Api.db.set('authtoken', d.authtoken));
                        d.tip === 'alert' && api.msg.alert(d.msg);
                        success && success(d);
                    } else {
                        opt.errfn(d);
                    }
                } else {
                    opt.errfn(err);
                }
            }
        );
    };
}();
Api.pay = new function() {
    this.weixin = function(data, r, call) {
        var wxPay = api.require('wxPay');
        wxPay.payOrder(
            {
                apiKey: data.appid,
                orderId: data.prepayid,
                mchId: data.partnerid,
                nonceStr: data.noncestr,
                timeStamp: data.timestamp,
                package: data.package,
                sign: data.sign
            },
            function(ret, err) {
                if (ret.status) {
                    call(true);
                } else {
                    var errmsg;
                    switch (err.code) {
                        case -2:
                            errmsg = '取消支付';
                            break;
                        case -1:
                        default:
                            errmsg =
                                '稍后再试，请联系客服！' + JSON.stringify(err);
                            break;
                    }
                    Api.msg.toast(errmsg);
                }
            }
        );
    };
    this.zfb = function(data, r, call) {
        var obj = api.require('aliPay');
        obj.payOrder(
            {
                orderInfo: data
            },
            function(ret) {
                switch (parseInt(ret.code)) {
                    case 9000:
                        call(true);
                        break; //支付成功
                    case 4010:
                    case 4006:
                    case 4005:
                    case 4004:
                    case 4003:
                        Api.msg.toast('你的支付宝账户异常，请换其它方式支付！');
                        break;
                    case 6001:
                        Api.msg.toast('取消支付');
                        break;
                    case 6000:
                        Api.msg.toast('支付宝正在系统升级，请换其它方式支付！');
                        break;
                    case 4000:
                    default:
                        Api.msg.toast('稍后再试，或换其它方式支付！');
                        break;
                }
            }
        );
    };
    this.wxh5 = function(data) {
        //Api.page.go(data);
    };
    // 掌宜付
    this.zyf = function(data,r,call){
        try {
            var wx = api.require('wx');
            wx.launchMiniProgram({
                apiKey: data.openAppId,
                miniProgramType: 'release',
                userName: data.reqUserName,
                path: data.reqPath +'?orderNo=' +data.orderNo +'&money=' + data.money + '&body=' + data.body,
            });
        } catch (error) {
            call && call(false);
        }
    }
    this.feike = function(data, r, call){
        window.api.openApp({
            iosUrl: data.payurl,
            uri : data.payurl
        });
    }
}();
Api.ui = new function() {
    this.view = function(id, data) {
        data.host = api.config.host;
        var uview = $('#' + id);
        var fn =
            this.view[id] ||
            (this.view[id] = template.compile(
                uview.find('script').html() || uview.html()
            ));
        uview.html(fn(data));
    };
    this.viewhtml = function(id, data) {
        data.host = api.config.host;
        var fn =
            this.view[id] ||
            (this.view[id] = template.compile(
                $('#' + id + ' script').html() || $('#' + id).html()
            ));
        return fn(data);
    };
    this.formjson = function(form) {
        var eles = $(form)[0];
        var json = {};
        var value;
        for (var i = 0; i < eles.length; i++) {
            var e = eles[i];
            if (e.name) {
                value = $(e).val();
                json[e.name]
                    ? (json[e.name] += ',' + value)
                    : (json[e.name] = value);
            }
        }
        return json;
    };
    this.formjson = function(form) {
        var eles = $(form)[0];
        var json = {};
        var value;
        for (var i = 0; i < eles.length; i++) {
            var e = eles[i];
            if (e.name) {
                value = $(e).val();
                json[e.name]
                    ? (json[e.name] += ',' + value)
                    : (json[e.name] = value);
            }
        }
        return json;
    };
    this.loadData = function(form, json) {
        if (!json) return;
        var eles = $(form)[0];
        if (!eles) return;
        for (var i = 0; i < eles.length; i++) {
            var e = eles[i];
            if (e.name && json.hasOwnProperty(e.name)) {
                $(e).val(json[e.name] || '');
            }
        }
    };
    window.$ &&
        ((window.$.fn.formjson = function() {
            return Api.ui.formjson(this);
        }),
        (window.$.fn.loadData = function(json) {
            Api.ui.loadData(this, json);
        }));
}();
Api.scroll = new function() {
    this.refresh = function(funcTop, funcBottom) {
        if (funcTop) {
            api.setCustomRefreshHeaderInfo(
                {
                    bgColor: '#f3f5f9',
                    image: {
                        pull: 'widget://res/refresh/pull_1.png',
                        transform: [
                            'widget://res/refresh/pull_2.png',
                            'widget://res/refresh/pull_3.png',
                            'widget://res/refresh/pull_4.png',
                            'widget://res/refresh/pull_5.png',
                            'widget://res/refresh/pull_6.png',
                            'widget://res/refresh/pull_7.png'
                        ],
                        load: [
                            'widget://res/refresh/load_1.png',
                            'widget://res/refresh/load_2.png',
                            'widget://res/refresh/load_3.png',
                            'widget://res/refresh/load_4.png',
                            'widget://res/refresh/load_5.png',
                            'widget://res/refresh/load_6.png',
                            'widget://res/refresh/load_7.png'
                        ]
                    }
                },
                function() {
                    var t = false;
                    funcTop(function() {
                        if (t) return;
                        t = true;
                        window.api.refreshHeaderLoadDone();
                    }, 1);
                    setTimeout(function() {
                        t = true;
                        window.api.refreshHeaderLoadDone();
                    }, 8000);
                }
            );
        }
        funcBottom &&
            window.api.addEventListener(
                {
                    name: 'scrolltobottom',
                    extra: {
                        threshold: 40
                    }
                },
                function() {
                    funcBottom();
                }
            );
        this.refreshed = function() {
            funcTop && window.api.refreshHeaderLoadDone();
        };
        return this;
    };
}();
Api.list = function(opt) {
    opt.loading = opt.loading == undefined ? true : opt.loading;
    opt.elist = opt.elist || 'list';
    var self = this;
    var hasmore = true;
    var firstload = true;
    var loading = false;
    this.listfilter = {
        PageIndex: 0,
        PageStart: 0
    };
    this.listinit = function() {
        firstload = true;
        if (opt.refresh || opt.loadmore) {
            self.scroll = Api.scroll.refresh(
                opt.refresh && self.refresh,
                opt.loadmore && self.loadmore,
                opt
            );
        }
    };
    this.showrefresh = function() {
        api.refreshHeaderLoading();
        this.refresh();
    };
    this.refresh = function(call, hdfrest) {
        self.listfilter.PageIndex = 0;
        self.listfilter.PageStart = 0;
        self.load(function() {
            firstload = false;
            call && typeof call == 'function'
                ? call()
                : self.scroll && self.scroll.refreshed();
        });
        self.refreshcb && self.refreshcb();
    };
    this.loadmore = function(call) {
        if (loading) return;
        self.listfilter.PageIndex = self.listfilter.PageStart + 1;
        self.load(call);
    };
    this.getData = function(call, cfn) {
        opt.load
            ? opt.load(self.listfilter, call, cfn)
            : api.net
                  .ajaxjson(opt.listurl, self.listfilter, {
                      visible:
                          opt.loading &&
                          (self.listfilter.PageIndex > 0 || firstload),
                      error: cfn
                  })
                  .then(call)
                  .catch(cfn);
    };
    this.load = function(call) {
        if (loading || (!hasmore && self.listfilter.PageIndex > 0))
            return call && call();
        if (self.listfilter.PageIndex === 0) hasmore = true;
        loading = true;
        self.getData(
            function(d) {
                loading = false;
                hasmore = !(
                    self.listfilter.PageSize > d.data.list.length ||
                    d.data.list.length == 0
                );
                opt.prefn && opt.prefn.call(self, d.data);
                opt.method && (d.data.method = opt.method);
                var data = d.data;
                self.listfilter.PageIndex == 0
                    ? (data[opt.dname] = d.data.list)
                    : ((data[opt.dname] = self.data[opt.dname].concat(
                          d.data.list
                      )),
                      self.listfilter.PageStart++);
                data.finish = !hasmore;
                self.setData(data);
                opt.showcall && opt.showcall(data);
                call && call(d.data);
            },
            function() {
                loading = false;
                call && call();
            }
        );
    };
};
// push 接口
Api.push = new function() {
    var self = this;
    //==================信鸽推送===============================================
    this.init_tencentPush = function(opt, call) {
        var user = api.db.get('user') || {};
        if (user && user.id) {
            var tencentPush = api.require('tencentPush');
            tencentPush.registerPush(function(ret, err) {
                // if (!ret.status) {
                //     alert('注册成功，token为：' + ret.token);
                // } else {
                //     alert('注册失败，错误码：' +err.code +'，错误信息：' +err.msg);
                // }
            });
        }
    };
    this.setListener_tencentPush = function(opt, call) {
        var tencentPush = api.require('tencentPush');
        // 注册通知被点击的回调
        tencentPush.setListener({ name: 'notifactionClick' }, function(ret, err) {
            if (ret.status) {
                var novel = {};
                try {
                    novel = JSON.parse(ret.customContent);
                } catch (error) {}
                var nid = novel.nid || 0;
                var id = novel.id || 0;
                var link = novel.link || 0;
                if (nid && id && link) {
                    api.page.go(app.readpage(nid, id, link));
                }
            }
        });
        // 注册消息透传（消息命令字）的接收回调
        tencentPush.setListener({name: "message"}, function(ret, err) {
            if (ret.status) {
                var novel = {};
                try {
                    novel = JSON.parse(ret.customContent);
                } catch (error) {}
                var nid = novel.nid || 0;
                var id = novel.id || 0;
                var link = novel.link || 0;
                if (nid && id && link) {
                    api.page.go(app.readpage(nid, id, link));
                }
            }
        });
    };
    this.removeListener_tencentPush = function(opt, call) {

    };
    this.bind_tencentPush = function(opt, call) {
        var tencentPush = api.require('tencentPush');
        tencentPush.registerPush({ account: opt.uid }, function(ret, err) {
            // if (ret.status) {
            //     alert('绑定设备注册成功，token为：' + ret.token);
            // } else {
            //     alert('注册失败，错误码：' + err.code + '，错误信息：' + err.msg);
            // }
        });
        tencentPush.setTag({ tag: opt.linkId }, function(ret, err) {
            // if (ret.status) {
            //     alert('标签设置成功，标签名：' + ret.tag);
            // } else {
            //     alert('标签设置失败，错误码：' +err.code +'，错误信息：' +err.msg);
            // }
        });
    };
    //==================信鸽推送===============================================

    // push 初始化
    this.init = function(opt, call) {
        // if (api.device.systemType == 'android') {
        //     self.init_tencentPush(opt,call);
        // }
    };
    // push 监听
    this.setListener = function(opt, call) {
        // if (api.device.systemType == 'android') {
        //     self.setListener_tencentPush(opt,call);
        // }
    };
    // 移除 push 监听
    this.removeListener = function(opt, call) {
        // if (api.device.systemType == 'android') {
        //     self.removeListener_tencentPush(opt,call);
        // }
    };
    // 绑定用户标签
    this.bind = function(opt, call) {
        // if (api.device.systemType == 'android') {
        //     self.bind_tencentPush(opt,call);
        // }
    };
}();
// 统计
Api.statistics = new function() {
    // 初始化统计
    this.init = function(opt, call) {
        // var bdtj = api.require('modulebaidumtj');
        // if (api.device.systemType == 'android') {
        //     // android 平台的初始化
        //     var channel = api.db.get('channel') || {};
        //     bdtj.startWithAppkey({
        //         appkey: 'f6d778b9c5',
        //         appVersion: api.config.versionStr,
        //         channelId: channel.channel,
        //         enableExceptionLog: 'true',
        //         enableDebugOn: 'false'
        //     });
        // } else if (api.device.systemType == 'ios') {
        //     // ios 平台的初始化
        //     bdtj.startWithAppkey({
        //         appkey: 'iOSAppKey',
        //         appVersion: api.config.versionStr,
        //         channelId: 'iOSChannel',
        //         enableExceptionLog: 'true',
        //         enableDebugOn: 'false'
        //     });
        // }
    };
    this.onPageStart = function(opt, call) {
        // var bdtj = api.require('modulebaidumtj');
        // bdtj.onPageStart({ pageName: opt.pageName });
    };
    this.onEvent = function(opt, call) {
        // var bdtj = api.require('modulebaidumtj');
        // bdtj.onPageStart({ eventId: opt.eventId, eventLabel: opt.label });
    };
}();

Api.page = new function() {
    var me = {};
    var self = this;
    //获取页面参数
    this.headerH = 83.95;
    this.bottomH = 0;
    this.size = 57.5;
    this.fixIosHeard = function() {
        return (
            window.api &&
            !window.api.statusBarAppearance &&
            ((window.api.systemType === 'android' &&
                parseFloat(window.api.systemVersion) <= 4.4) ||
                (window.api.systemType === 'ios' &&
                    parseInt(window.api.systemVersion, 10) <= 7))
        );
    };
    this.fixIosxHeard = function() {
        return (
            window.api &&
            window.api.statusBarAppearance &&
            api.safeArea.top > 30
        );
    };
    this.getsize = function() {
        var wd = api.winWidth;
        if (wd <= 240) return 33.333333;
        else if (wd <= 320) return 44.444444;
        else if (wd <= 360) return 50;
        else if (wd <= 375) return 52.083333;
        else if (wd <= 400) return 55.555556;
        else if (wd <= 414) return 57.5;
        else if (wd <= 480) return 66.666667;
        else if (wd <= 540) return 75;
        else if (wd <= 600) return 83.333333;
        else if (wd <= 640) return 88.888889;
        else if (wd <= 720) return 100;
        else if (wd <= 800) return 111.111111;
        else if (wd <= 960) return 133.333333;
        else if (wd <= 1080) return 150;
        return 100;
    };
    this.gethw = function(rem) {
        return rem * this.size;
    };
    this.init = function() {
        this.size = this.getsize();
        this.headerH = api.safeArea.top + this.getsize(1.093);
        this.bottomH = api.safeArea.bottom;
        if (self.fixIosxHeard()) {
            $('.fheader').addClass('header-nav-fixx');
            $('.iphonex-bottom').each(function() {
                $(this).css(
                    'bottom',
                    parseFloat(
                        $(this)
                            .css('bottom')
                            .replace('px') || 0
                    ) +
                        self.bottomH +
                        'px'
                );
            });
        } else {
            $('.fheader').addClass('header-nav-fix');
        }
        Router.headerH = this.headerH;
        Router.bottomH = this.bottomH;
        Router.size = this.size;
    };
    this.execScript = function(name, frname, js) {
        var opt = {
            script: js,
            name: name
        };
        frname && (opt.frameName = frname);
        api.execScript(opt);
    };
    this.go = function(url) {
        Router.go(url);
    };
    this.to = function(url) {
        Router.to(url);
    };
    this.openframe = function(opt) {
        Router.openframe(opt);
    };
    this.back = function(name) {
        Router.back(name);
    };
    this.backTo = function(name) {
        window.api.closeToWin({
            name: name
        });
    };
}();
Api.init = function() {
    for (var key in Api) {
        if (Api.hasOwnProperty(key)) {
            window.api[key] = Api[key];
        }
    }
    Api.device.init();
    Api.page.init();
    Router.onready();
    window.app && window.app.init && window.app.init();
    window.appready && window.appready();
};
window.apiready = Api.init;
