/*
 * @Author: xueping
 * @Date: 2018-07-13 22:59:34
 * @Last Modified by: xueping
 * @Last Modified time: 2019-02-28 18:49:18
 * @blog:http://qingdie.me
 */
window.Router = new function($) {
    var me = {};
    var EVENTS = {
        onready: '',
        onanmterEnd: '',
        routerInited: 'routerInited'
    };
    var config = {
        version:
            (window.Api && Api.config && Api.config.version) ||
            new Date().getTime(),
        pageclass: '.page'
    };
    var windef = {
        hScrollBarEnabled: false,
        slidBackType: 'edge',
        bgColor: 'ffffff',
        animation: {
            type: 'push',
            subType: 'from_right',
            duration: 300
        },
        progress: {
            type: 'default',
            title: '加载中...'
        }
    };
    var framedef = {
        hScrollBarEnabled: false,
        bounces: true,
        rect: {
            x: 0,
            y: 83.95,
            w: 'auto',
            h: 'auto',
            marginBottom: 0
        },
        progress: {
            type: 'default',
            title: '加载中...'
        }
    };
    var currpage;
    me.urlparam = function(url) {
        url = url || window.location.search;
        if (url.indexOf('?') === -1) return {};
        url = url.substring(url.indexOf('?') + 1, url.length);
        var urldata = {};
        var arr = url.split('&');
        for (var i = 0; i < arr.length; i++) {
            var parr = arr[i].split('=');
            parr[0] && (urldata[parr[0]] = parr[1]);
        }
        return urldata;
    };
    me.resetopt = function(opt1, opt2) {
        opt1 = opt1 || {};
        for (var key in opt2) {
            if (opt2.hasOwnProperty(key)) {
                if (opt2[key] != undefined) {
                    if (typeof opt2[key] == 'object') {
                        me.resetopt(opt1[key] || (opt1[key] = {}), opt2[key]);
                    } else {
                        opt1[key] == undefined && (opt1[key] = opt2[key]);
                    }
                }
            }
        }
        return opt1;
    };
    me.pageopt = function(opt, dopt) {
        typeof opt === 'string' &&
            (opt = {
                url: opt
            });
        opt = me.resetopt(opt, dopt);
        !opt.name && (opt.name = me.cpagename(opt.url));
        !opt.pageParam && (opt.pageParam = me.urlparam(opt.url));
        if (opt.url.indexOf('http') != 0) opt.url = opt.url.split('?')[0];
        if (opt.url.indexOf('/') == 0 && opt.url.indexOf('.html') == -1)
            opt.url += '.html';
        if (opt.url.indexOf('/') == 0) opt.url = 'widget:/' + opt.url;
        return opt;
    };
    me.cpagename = function(to) {
        var arr = to.split('/');
        var lt;
        var name =
            (arr[arr.length - 2] ||
                ((lt = window.location.pathname.split('/')),
                lt[lt.length - 2])) + arr[arr.length - 1].split('.')[0];
        name = name.split('?');
        return name[0];
    };
    me.cpageId = function(url) {
        if (url.indexOf('#') > -1) {
            url = url.split('#')[1];
        }
        if (url.indexOf('?') > -1) {
            url = url.split('?')[0];
        }
        return url.replace(/\//g, '-').split('.')[0];
    };
    me._eventinit = function() {
        if (!window.CustomEvent) {
            window.CustomEvent = function(type, config) {
                config = config || {
                    bubbles: false,
                    cancelable: false,
                    detail: undefined
                };
                var e = document.createEvent('CustomEvent');
                e.initCustomEvent(
                    type,
                    config.bubbles,
                    config.cancelable,
                    config.detail
                );
                return e;
            };
            window.CustomEvent.prototype = window.Event.prototype;
        }

        function __dealCssEvent(eventNameArr, callback) {
            var events = eventNameArr,
                i,
                dom = this;

            function fireCallBack(e) {
                if (e.target !== this) return;
                callback.call(this, e);
                for (i = 0; i < events.length; i++) {
                    dom.off(events[i], fireCallBack);
                }
            }
            if (callback) {
                for (i = 0; i < events.length; i++) {
                    dom.on(events[i], fireCallBack);
                }
            }
        }
        $.fn.animationEnd = function(callback) {
            var isend = true;
            var anobj = setTimeout(function() {
                isend && ((isend = false), callback());
            }, 1200);
            __dealCssEvent.call(
                this,
                ['webkitAnimationEnd', 'animationend'],
                function() {
                    clearTimeout(anobj);
                    isend && ((isend = false), callback());
                }
            );
            return this;
        };
        $.fn.transitionEnd = function(callback) {
            __dealCssEvent.call(
                this,
                ['webkitTransitionEnd', 'transitionend'],
                callback
            );
            return this;
        };
    };
    this.headerH = 83.95;
    this.bottomH = 0;
    this.size = 57.5;
    this.on = function(name, evt) {
        EVENTS[name] = evt;
    };
    this.onready = function() {
        framedef.rect.y = this.headerH;
        EVENTS.onready && EVENTS.onready(api.pageParam || {});
        EVENTS.onanmterEnd && EVENTS.onanmterEnd();
        this._dispatch(EVENTS.routerInited);
    };
    this.go = function(url) {
        console.log(url);
        var opt = me.pageopt(url, windef);
        window.api.openWin(opt);
    };
    this.openframe = function(opt) {
        !opt.pageParam && api.pageParam && (opt.pageParam = api.pageParam);
        opt = me.pageopt(opt, framedef);
        opt.iphonex && (opt.rect.marginBottom += this.bottomH);
        window.api.openFrame(opt);
    };
    this.to = function(url) {
        var name = api.winName;
        setTimeout(function() {
            api.closeWin({
                name: name
            });
        }, 500);
        this.go(url);
    };
    this.back = function(name) {
        if (name) {
            api.closeWin({ name: name });
        } else {
            window.api.closeWin();
        }
    };
    this._dispatch = function(event, detail) {
        var e = new CustomEvent(event, {
            bubbles: true,
            detail: detail,
            cancelable: true
        });
        window.dispatchEvent(e);
    };
    me._eventinit();
}(Zepto);
